/*------------------------------------------------------------------------------- 
Code to receive with a ADSP-21160 link port(4) from a ADSP-21062. The DSP's I/O 
processor manages the DMA transfer through the link port. The DMA operation transfers
and stores an entire block of data in DM data memory. In order to receive from a 
ADSP-21160 using 8 bit data width the corresponding LxDPWID must be set.
-------------------------------------------------------------------------------*/
#include    "def21160.h"

#define N       512					/* lenght of receive data */

/*------------ DM data --------------*/
.section/dm seg_dmda;
.var dest[N];

/*---- PM interrupt vector code -----*/
.section/pm   seg_rth;
Reserved_1:     rti; nop; nop; nop;
Chip_Reset:     idle; jump begin; nop; nop;

/*------ program memory code -------*/
.section/pm seg_pmco;
	
begin:		ustat1 = dm(SYSCON);	/* Clear Buffer Hang Disable	*/
			bit clr ustat1 BHD; 
			dm(SYSCON) = ustat1;
			
			r0=0;					/* Clear Link Control Registers */
			dm(LAR)=r0;	    
			dm(LCTL1)=r0;

									/* Set up DMA pointers */
			r0=dest;				/* Set DMA channel 8 Index Register */
			dm(II8)=r0;
	
			r0=1;
			dm(IM8)=r0;				/* Set DMA channel 8 Modify Register */

			r0=@dest;
			dm(C8)=r0;				/* Set DMA channel 8 count Register */
			
			r0=0x4000;				/* LBUF4->LPORT4, all other ports are disabled */
			dm(LAR)=r0;	 
			
			r0=L4EN | L4DEN | L4CLKD1;/*LBUF4 enable port and dma, receive,word size, 1/2 clock, 4bit data path*/
			dm(LCTL1)=r0;			/*always write LCTLx after LAR*/	

/* terminate and wait */
wait1: 
jump wait1;
/*-----------------------------------------------------------------------------*/
