/*------------------------------------------------------------------------------- 
Code to transmit with a ADSP-21062 link port(5) to a ADSP-21160. The DSP's I/O 
processor manages the DMA transfer through the link port. The DMA operation transfers
an entire block of data located in DM data memory. 
-------------------------------------------------------------------------------*/

#include	"def21060.h"

#define N 512	/* lenght of sample data should be a even number */

/*------------ DM data --------------*/
.section/dm seg_dmda;
.VAR source[N];

/*---- PM interrupt vector code -----*/
.section/pm   seg_rth;
Reserved_1:     rti; nop; nop; nop;
Chip_Reset:     idle; jump start; nop; nop;

/*------ program memory code -------*/
.section/pm seg_pmco;

		/* computes sample data to be transmitted in one DMA transfer block */	  
start:	b0=source; b1=b0; i0=source+N/4; i1=source+3*N/4;
		l0=N; l1=N;	m0=1; r0=N/4; r1=-N/4-1;	/* triangle function period=N, amplitude=N/2 */

		lcntr=N/2, do compute until lce;
		r1=r1+1; dm(i0,m0)=r0;
compute:r0=r0-1, dm(i1,m0)=r1;	/* proper transmission can be easily verified 
								using the debug window plot function */	 


setup:	ustat1 = dm(SYSCON);	/* Clear Buffer Hang Disable	*/
		bit clr ustat1 0x800; 
		dm(SYSCON) = ustat1;

		r0=0x00000000;			/* Clear Link Control Register */
		dm(LCTL)=r0;
		dm(LAR)=r0;
								/* Set up DMA pointers */
		r0=source;				/* Set DMA channel 4 Index Register */
		dm(II4)=r0;
	
		r0=1;
		dm(IM4)=r0;				/* Set DMA channel 4 Modify Register */

		r0=@source;				/* Set DMA channel 4 count Register */
		dm(C4)=r0;
			
		r0=0x0000000; 			/* transfer on clock rate, disable 2-D DMA, disable link pull-down resistor*/
		dm(LCOM)=r0;

		r0=0x3ff7f;				/* LBUF2 <==> LPORT5, all others disabled */
		dm(LAR)=r0;

		r9=0x00000b00;			/* lbuf2 enable, transmit, 32-bit word, 4-bit bus width, DMA */
		dm(LCTL)=r9;

		/* terminate and wait */		
wait1:	idle;
		jump wait1;

.endseg;
/*-----------------------------------------------------------------------------*/
