/*------------------------------------------------------------------------------- 
Code to receive with a ADSP-21160 link port(4) from a ADSP-21062. The core directly 
reads N values from the link buffer(LBUF4). The core will hang on the read of 
LBUF4 until data is ready to receive. Received values are stored DM Memory. 
-------------------------------------------------------------------------------*/

#include    "def21160.h"

#define N       1024
        
/*------------ DM data --------------*/
.section/dm seg_dmda;
/*data to be transmitted to SHARC*/
.VAR dest[N];
 
/*---- PM interrupt vector code -----*/
.section/pm   seg_rth;
Reserved_1:     rti; nop; nop; nop;
Chip_Reset:     idle; jump begin; nop; nop;

/*------ program memory code -------*/
.section/pm seg_pmco;

begin:
		b2=dest;
		l2=N;
		m2=1;

		ustat1 = dm(SYSCON);	/* Clear Buffer Hang Disable	*/
		bit clr ustat1 BHD; 
		dm(SYSCON) = ustat1;

		r0=0;					/*clear link control registers*/
		dm(LAR)=r0;	    
		dm(LCTL1)=r0;

		r0=0x4000;				/* LBUF4->LPORT4, all other ports are disabled */
		dm(LAR)=r0;	 
		r0=L4EN | L4CLKD1;		/*LBUF4 enable port, RX, 32bit word size, 
								  1/2 clock, 4bit data path*/
		dm(LCTL1)=r0;			/*always write LCTLx after LAR*/
		r2=N;

readstat:
		ustat1=dm(LCOM);		/* read Link Port common Control Register */
		bit tst ustat1 L4STAT0 ;	/* test buffer full */
		if not tf jump readstat;/* test until word is received */
		r2=r2-1;				/* count received words */
			
		if GT jump readstat (DB);
		r1=dm(LBUF4);			/* save received words until count expired */
		dm(i2,m2)=r1;

		/* terminate and wait */
wait1: 
jump wait1;
/*-----------------------------------------------------------------------------*/
